Index: code/trunk/src/external/bullet/BulletPrecompiledHeaders.h
===================================================================
--- code/trunk/src/external/bullet/BulletPrecompiledHeaders.h	(revision 5749)
+++ code/trunk/src/external/bullet/BulletPrecompiledHeaders.h	(revision 5749)
@@ -0,0 +1,48 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Reto Grieder
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/**
+@file
+@brief
+    Compilation of the most often used header files in the external bullet library
+@details
+    Updated: 19. September 2009
+    Total Files: 105
+*/
+
+///////////////////////////////////////////
+/////          Stable Headers         /////
+///////////////////////////////////////////
+
+#include <bullet/bulletcollision/collisionshapes/btConvexInternalShape.h> // 37
+#include <bullet/bulletcollision/collisiondispatch/btCollisionObject.h> // 33
+
+
+// Just in case some header included windows.h
+#undef min
+#undef max
Index: code/trunk/src/external/bullet/CMakeLists.txt
===================================================================
--- code/trunk/src/external/bullet/CMakeLists.txt	(revision 5748)
+++ code/trunk/src/external/bullet/CMakeLists.txt	(revision 5749)
@@ -34,4 +34,6 @@
   ORXONOX_EXTERNAL
   NO_DLL_INTERFACE
+  PCH_FILE
+    BulletPrecompiledHeaders.h
   VERSION
     2.74
Index: code/trunk/src/libraries/core/CorePrecompiledHeaders.h
===================================================================
--- code/trunk/src/libraries/core/CorePrecompiledHeaders.h	(revision 5748)
+++ code/trunk/src/libraries/core/CorePrecompiledHeaders.h	(revision 5749)
@@ -30,52 +30,57 @@
 @file
 @brief
-    Compilation of the most often used header files in the core library for MSVC
+    Compilation of the most often used header files in the core library
+@details
+    Updated: 13. September 2009
+    Total Files: 56
 */
 
 #include "OrxonoxConfig.h"
 
-#include <cassert>
-#include <fstream>
-#include <iostream>
-#include <list>
-#include <locale>
-#include <map>
-#include <queue>
-#include <set>
-#include <sstream>
-#include <stack>
-#include <string>
-#include <vector>
+///////////////////////////////////////////
+/////          Stable Headers         /////
+///////////////////////////////////////////
 
+#include <string>   // 54
+#include <vector>   // 54
+#include <cassert>  // 53
+#include <fstream>  // 53
+#include <iostream> // 53
+#include <map>      // 53
+#include <sstream>  // 53
+#include <set>      // 50
+
+#include "util/Debug.h" // 48
+
+#include <deque>    // 43
+#include <list>     // 44
+#include <cmath>    // 42
+
+#include "util/ScopeGuard.h" // 38
+
+#include <OgreMath.h>        // 36
+#include <OgreVector2.h>     // 36
+#include <OgreVector3.h>     // 36
+#include <OgreVector4.h>     // 36
+#include <OgreQuaternion.h>  // 36
+#include <OgreColourValue.h> // 36
+#include <boost/preprocessor/cat.hpp> // 27
+#include <boost/shared_ptr.hpp> // 21
 
 #ifdef ORXONOX_COMPILER_MSVC
 
-#include <OgreMath.h>
-#include <OgreVector2.h>
-#include <OgreVector3.h>
-#include <OgreVector4.h>
-#include <OgreQuaternion.h>
-#include <OgreColourValue.h>
+#include <ois/OISKeyboard.h> // 15
+#include <ois/OISMouse.h>    // 15
+#include <ois/OISJoyStick.h> // 15
 
-#include <boost/shared_ptr.hpp> // 12
-#include <boost/preprocessor/cat.hpp> // 12
+#include "util/SubString.h"  // 14
+
+#include <boost/scoped_ptr.hpp> // 13
+#include <stack> // 12
+
+#endif /*ORXONOX_COMPILER_MSVC */
+
 
 // Just in case some header included windows.h
 #undef min
 #undef max
-
-#endif /* ORXONOX_COMPILER_MSVC */
-
-
-#include "util/Debug.h"
-#include "util/Math.h"
-#include "util/MultiType.h"
-#include "util/SubString.h"
-
-
-#ifdef ORXONOX_COMPILER_MSVC
-
-// A change would trigger an 80% Core rebuild anyway
-#include "Identifier.h"
-
-#endif /*ORXONOX_COMPILER_MSVC */
Index: code/trunk/src/libraries/network/ClientConnection.cc
===================================================================
--- code/trunk/src/libraries/network/ClientConnection.cc	(revision 5748)
+++ code/trunk/src/libraries/network/ClientConnection.cc	(revision 5749)
@@ -30,4 +30,5 @@
 
 #include <cassert>
+#define WIN32_LEAN_AND_MEAN
 #include <enet/enet.h>
 #include "util/Debug.h"
Index: code/trunk/src/libraries/network/ClientInformation.cc
===================================================================
--- code/trunk/src/libraries/network/ClientInformation.cc	(revision 5748)
+++ code/trunk/src/libraries/network/ClientInformation.cc	(revision 5749)
@@ -40,4 +40,5 @@
 
 #include "ClientInformation.h"
+#define WIN32_LEAN_AND_MEAN
 #include <enet/enet.h>
 
Index: code/trunk/src/libraries/network/Connection.cc
===================================================================
--- code/trunk/src/libraries/network/Connection.cc	(revision 5748)
+++ code/trunk/src/libraries/network/Connection.cc	(revision 5749)
@@ -30,4 +30,5 @@
 
 #include <cassert>
+#define WIN32_LEAN_AND_MEAN
 #include <enet/enet.h>
 #include "packet/Packet.h"
Index: code/trunk/src/libraries/network/NetworkPrecompiledHeaders.h
===================================================================
--- code/trunk/src/libraries/network/NetworkPrecompiledHeaders.h	(revision 5748)
+++ code/trunk/src/libraries/network/NetworkPrecompiledHeaders.h	(revision 5749)
@@ -31,36 +31,51 @@
 @brief
     Compilation of the most often used header files in the network library
+@details
+    Updated: 13. September 2009
+    Total Files: 28
 */
 
 #include "OrxonoxConfig.h"
 
-#include <cassert>
-#include <fstream>
-#include <iostream>
-#include <list>
-#include <map>
-#include <queue>
-#include <set>
-#include <sstream>
-#include <string>
-#include <vector>
+///////////////////////////////////////////
+/////          Stable Headers         /////
+///////////////////////////////////////////
 
+#include <cstring>  // 26
+#include <cassert>  // 24
+#include <string>   // 23
+#include <vector>   // 23
+#include <map>      // 23
+#include <fstream>  // 22
+#include <iostream> // 22
+#include <sstream>  // 22
+#include <set>      // 20
+
+#include "util/Debug.h"      // 20
+#include "util/TypeTraits.h" // 18
 
 #ifdef ORXONOX_COMPILER_MSVC
 
-#include <OgreMath.h>
-#include <OgreVector2.h>
-#include <OgreVector3.h>
-#include <OgreVector4.h>
-#include <OgreQuaternion.h>
-#include <OgreColourValue.h>
+#include <deque>    // 17
+#include <queue>    // 17
+#include <list>     // 16
+#include <cmath>    // 15
+
+#include <OgreMath.h>        // 15
+#include <OgreVector2.h>     // 15
+#include <OgreVector3.h>     // 15
+#include <OgreVector4.h>     // 15
+#include <OgreQuaternion.h>  // 15
+#include <OgreColourValue.h> // 15
+
+#include "util/mbool.h" // 11
 
 #define WIN32_LEAN_AND_MEAN
-#include <enet/enet.h>
+#include <enet/enet.h> // 6, 3.1MB
+
+#endif /*ORXONOX_COMPILER_MSVC */
+
+
+// Just in case some header included windows.h
+#undef min
 #undef max
-#undef min
-
-#include "util/Debug.h"
-#include "core/Identifier.h"
-
-#endif /* ORXONOX_COMPILER_MSVC */
Index: code/trunk/src/libraries/network/Server.cc
===================================================================
--- code/trunk/src/libraries/network/Server.cc	(revision 5748)
+++ code/trunk/src/libraries/network/Server.cc	(revision 5749)
@@ -41,4 +41,5 @@
 #include "Server.h"
 
+#define WIN32_LEAN_AND_MEAN
 #include <enet/enet.h>
 #include <cassert>
Index: code/trunk/src/libraries/network/ServerConnection.cc
===================================================================
--- code/trunk/src/libraries/network/ServerConnection.cc	(revision 5748)
+++ code/trunk/src/libraries/network/ServerConnection.cc	(revision 5749)
@@ -31,4 +31,5 @@
 #include <cassert>
 #include <string>
+#define WIN32_LEAN_AND_MEAN
 #include <enet/enet.h>
 
Index: code/trunk/src/libraries/network/packet/Packet.cc
===================================================================
--- code/trunk/src/libraries/network/packet/Packet.cc	(revision 5748)
+++ code/trunk/src/libraries/network/packet/Packet.cc	(revision 5749)
@@ -32,4 +32,5 @@
 #include <cassert>
 #include <cstring>
+#define WIN32_LEAN_AND_MEAN
 #include <enet/enet.h>
 #include <boost/static_assert.hpp>
Index: code/trunk/src/libraries/tools/CMakeLists.txt
===================================================================
--- code/trunk/src/libraries/tools/CMakeLists.txt	(revision 5748)
+++ code/trunk/src/libraries/tools/CMakeLists.txt	(revision 5749)
@@ -14,4 +14,7 @@
 
 ORXONOX_ADD_LIBRARY(tools
+  FIND_HEADER_FILES
+  PCH_FILE
+    ToolsPrecompiledHeaders.h
   DEFINE_SYMBOL
     "TOOLS_SHARED_BUILD"
Index: code/trunk/src/libraries/tools/ToolsPrecompiledHeaders.h
===================================================================
--- code/trunk/src/libraries/tools/ToolsPrecompiledHeaders.h	(revision 5749)
+++ code/trunk/src/libraries/tools/ToolsPrecompiledHeaders.h	(revision 5749)
@@ -0,0 +1,70 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Reto Grieder
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/**
+@file
+@brief
+    Compilation of the most often used header files in the tools library
+@details
+    Updated: 19. September 2009
+    Total Files: 11
+*/
+
+#include "OrxonoxConfig.h"
+
+///////////////////////////////////////////
+/////          Stable Headers         /////
+///////////////////////////////////////////
+
+#include <cassert>  // 11
+#include <cstring>  // 11
+#include <fstream>  // 11
+#include <iostream> // 11
+#include <map>      // 11
+#include <set>      // 11
+#include <sstream>  // 11
+#include <string>   // 11
+#include <vector>   // 11
+#include <cmath>    // 10
+#include <deque>    // 10
+#include <list>     // 10
+#include <queue>    // 10
+
+#include <OgreMath.h>        // 10
+#include <OgreVector2.h>     // 10
+#include <OgreVector3.h>     // 10
+#include <OgreVector4.h>     // 10
+#include <OgreQuaternion.h>  // 10
+#include <OgreColourValue.h> // 10
+
+#include "util/Debug.h"      // 9
+
+
+// Just in case some header included windows.h
+#undef min
+#undef max
Index: code/trunk/src/libraries/util/CMakeLists.txt
===================================================================
--- code/trunk/src/libraries/util/CMakeLists.txt	(revision 5748)
+++ code/trunk/src/libraries/util/CMakeLists.txt	(revision 5749)
@@ -34,35 +34,4 @@
 )
 
-SET_SOURCE_FILES(UTIL_HDR_FILES
-  CRC32.h
-  Clipboard.h
-  Convert.h
-  Debug.h
-  Exception.h
-  ExprParser.h
-  Math.h
-  MathConvert.h
-  mbool.h
-  MultiType.h
-  MultiTypeValue.h
-  OgreForwardRefs.h
-  OrxAssert.h
-  OrxEnum.h
-  OutputBuffer.h
-  OutputHandler.h
-  RefToValue.h
-  ScopeGuard.h
-  Serialise.h
-  SignalHandler.h
-  Singleton.h
-  Sleep.h
-  StringUtils.h
-  SubString.h
-  TemplateUtils.h
-  TypeTraits.h
-  UTFStringConversions.h
-  UtilPrereqs.h
-)
-
 IF(GCC_NO_SYSTEM_HEADER_SUPPORT)
   # Get around displaying a few hundred lines of warning code
@@ -71,4 +40,5 @@
 
 ORXONOX_ADD_LIBRARY(util
+  FIND_HEADER_FILES
   DEFINE_SYMBOL
     "UTIL_SHARED_BUILD"
@@ -77,4 +47,4 @@
     ${OGRE_LIBRARY}
   SOURCE_FILES
-    ${UTIL_SRC_FILES} ${UTIL_HDR_FILES}
+    ${UTIL_SRC_FILES}
 )
Index: code/trunk/src/modules/gamestates/CMakeLists.txt
===================================================================
--- code/trunk/src/modules/gamestates/CMakeLists.txt	(revision 5748)
+++ code/trunk/src/modules/gamestates/CMakeLists.txt	(revision 5749)
@@ -13,4 +13,7 @@
 ORXONOX_ADD_LIBRARY(gamestates
   MODULE
+  FIND_HEADER_FILES
+  PCH_FILE
+    GameStatesPrecompiledHeaders.h
   DEFINE_SYMBOL
     "GAMESTATES_SHARED_BUILD"
Index: code/trunk/src/modules/gamestates/GameStatesPrecompiledHeaders.h
===================================================================
--- code/trunk/src/modules/gamestates/GameStatesPrecompiledHeaders.h	(revision 5749)
+++ code/trunk/src/modules/gamestates/GameStatesPrecompiledHeaders.h	(revision 5749)
@@ -0,0 +1,58 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Reto Grieder
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/**
+@file
+@brief
+    Compilation of the most often used header files in the game states module
+@details
+    Updated: 19. September 2009
+    Total Files: 9
+*/
+
+#include "OrxonoxConfig.h"
+
+///////////////////////////////////////////
+/////          Stable Headers         /////
+///////////////////////////////////////////
+
+#include "util/SubString.h"       // 6
+#include "util/OgreForwardRefs.h" // 6
+
+///////////////////////////////////////////
+/////       All Rebuild Headers       /////
+///////////////////////////////////////////
+
+#include "core/GameState.h" // 9
+#include "core/Game.h"      // 9
+#include "util/MultiType.h" // 8
+
+
+// Just in case some header included windows.h
+#undef min
+#undef max
Index: code/trunk/src/modules/objects/CMakeLists.txt
===================================================================
--- code/trunk/src/modules/objects/CMakeLists.txt	(revision 5748)
+++ code/trunk/src/modules/objects/CMakeLists.txt	(revision 5749)
@@ -12,4 +12,7 @@
 ORXONOX_ADD_LIBRARY(objects
   MODULE
+  FIND_HEADER_FILES
+  PCH_FILE
+    ObjectsPrecompiledHeaders.h
   DEFINE_SYMBOL
     "OBJECTS_SHARED_BUILD"
Index: code/trunk/src/modules/objects/ObjectsPrecompiledHeaders.h
===================================================================
--- code/trunk/src/modules/objects/ObjectsPrecompiledHeaders.h	(revision 5749)
+++ code/trunk/src/modules/objects/ObjectsPrecompiledHeaders.h	(revision 5749)
@@ -0,0 +1,64 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Reto Grieder
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/**
+@file
+@brief
+    Compilation of the most often used header files in the objects module
+@details
+    Updated: 19. September 2009
+    Total Files: 15
+*/
+
+#include "OrxonoxConfig.h"
+
+///////////////////////////////////////////
+/////          Stable Headers         /////
+///////////////////////////////////////////
+
+#include <LinearMath/btTransform.h> // 11
+
+///////////////////////////////////////////
+/////       All Rebuild Headers       /////
+///////////////////////////////////////////
+
+#include "core/BaseObject.h"   // 15
+#include "core/CoreIncludes.h" // 15
+#include "core/XMLPort.h"      // 13
+
+///////////////////////////////////////////
+/////      Not so Stable Headers      /////
+///////////////////////////////////////////
+
+#include "network/synchronisable/Synchronisable.h" // 11
+//#include "orxonox/worldentities/StaticEntity.h" // 7
+
+
+// Just in case some header included windows.h
+#undef min
+#undef max
Index: code/trunk/src/modules/overlays/CMakeLists.txt
===================================================================
--- code/trunk/src/modules/overlays/CMakeLists.txt	(revision 5748)
+++ code/trunk/src/modules/overlays/CMakeLists.txt	(revision 5749)
@@ -12,4 +12,6 @@
   MODULE
   FIND_HEADER_FILES
+  PCH_FILE
+    OverlaysPrecompiledHeaders.h
   DEFINE_SYMBOL
     "OVERLAYS_SHARED_BUILD"
Index: code/trunk/src/modules/overlays/OverlaysPrecompiledHeaders.h
===================================================================
--- code/trunk/src/modules/overlays/OverlaysPrecompiledHeaders.h	(revision 5749)
+++ code/trunk/src/modules/overlays/OverlaysPrecompiledHeaders.h	(revision 5749)
@@ -0,0 +1,67 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Reto Grieder
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/**
+@file
+@brief
+    Compilation of the most often used header files in the overlays module
+@details
+    Updated: 19. September 2009
+    Total Files: 21
+*/
+
+#include "OrxonoxConfig.h"
+
+///////////////////////////////////////////
+/////          Stable Headers         /////
+///////////////////////////////////////////
+
+#include <tinyxml/ticpp.h> // 14
+//#include <OgreOverlayelement.h> // 7, 7.2MB
+#include <bullet/linearmath/btMotionState.h> // 6
+//#include <OgrePanelOverlayelement.h> // 5
+
+///////////////////////////////////////////
+/////       All Rebuild Headers       /////
+///////////////////////////////////////////
+
+#include "overlays/OrxonoxOverlay.h" // 21
+#include "core/CoreIncludes.h"       // 20
+
+///////////////////////////////////////////
+/////      Not so Stable Headers      /////
+///////////////////////////////////////////
+
+#include "core/Executor.h"     // 13
+//#include "network/synchronisable/Synchronisable.h" // 13
+//#include "core/XMLPort.h"    // 9
+
+
+// Just in case some header included windows.h
+#undef min
+#undef max
Index: code/trunk/src/modules/pong/CMakeLists.txt
===================================================================
--- code/trunk/src/modules/pong/CMakeLists.txt	(revision 5748)
+++ code/trunk/src/modules/pong/CMakeLists.txt	(revision 5749)
@@ -11,4 +11,8 @@
 ORXONOX_ADD_LIBRARY(pong
   MODULE
+  FIND_HEADER_FILES
+  PCH_FILE
+    PongPrecompiledHeaders.h
+  PCH_NO_DEFAULT
   DEFINE_SYMBOL
     "PONG_SHARED_BUILD"
Index: code/trunk/src/modules/pong/PongPrecompiledHeaders.h
===================================================================
--- code/trunk/src/modules/pong/PongPrecompiledHeaders.h	(revision 5749)
+++ code/trunk/src/modules/pong/PongPrecompiledHeaders.h	(revision 5749)
@@ -0,0 +1,58 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Reto Grieder
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/**
+@file
+@brief
+    Compilation of the most often used header files in the pong module
+@details
+    Updated: 19. September 2009
+    Total Files: 7
+*/
+
+#include "OrxonoxConfig.h"
+
+///////////////////////////////////////////
+/////          Stable Headers         /////
+///////////////////////////////////////////
+
+#include "util/OgreForwardRefs.h" // 6
+
+///////////////////////////////////////////
+/////       All Rebuild Headers       /////
+///////////////////////////////////////////
+
+#include "core/BaseObject.h"   // 7
+#include "core/CoreIncludes.h" // 7
+#include "core/Executor.h"     // 6
+#include "network/synchronisable/Synchronisable.h" // 7
+
+
+// Just in case some header included windows.h
+#undef min
+#undef max
Index: code/trunk/src/modules/questsystem/CMakeLists.txt
===================================================================
--- code/trunk/src/modules/questsystem/CMakeLists.txt	(revision 5748)
+++ code/trunk/src/modules/questsystem/CMakeLists.txt	(revision 5749)
@@ -25,4 +25,5 @@
 ORXONOX_ADD_LIBRARY(questsystem
   MODULE
+  FIND_HEADER_FILES
   TOLUA_FILES
     QuestDescription.h
@@ -30,4 +31,6 @@
   DEFINE_SYMBOL
     "QUESTSYSTEM_SHARED_BUILD"
+  PCH_FILE
+    QuestsystemPrecompiledHeaders.h
   LINK_LIBRARIES
     orxonox
Index: code/trunk/src/modules/questsystem/QuestsystemPrecompiledHeaders.h
===================================================================
--- code/trunk/src/modules/questsystem/QuestsystemPrecompiledHeaders.h	(revision 5749)
+++ code/trunk/src/modules/questsystem/QuestsystemPrecompiledHeaders.h	(revision 5749)
@@ -0,0 +1,73 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Reto Grieder
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/**
+@file
+@brief
+    Compilation of the most often used header files in the quest system module
+@details
+    Updated: 19. September 2009
+    Total Files: 24
+*/
+
+#include "OrxonoxConfig.h"
+
+///////////////////////////////////////////
+/////          Stable Headers         /////
+///////////////////////////////////////////
+
+#include <ctime> // 18
+
+#include <OgreMath.h>        // 16
+#include <OgreVector2.h>     // 16
+#include <OgreVector3.h>     // 16
+#include <OgreVector4.h>     // 16
+#include <OgreQuaternion.h>  // 16
+#include <OgreColourValue.h> // 16
+
+#include <tinyxml/ticpp.h>        // 14
+#include "util/ScopedSingleton.h" // 13
+
+///////////////////////////////////////////
+/////       All Rebuild Headers       /////
+///////////////////////////////////////////
+
+#include "core/BaseObject.h"   // 24
+#include "core/CoreIncludes.h" // 23
+
+///////////////////////////////////////////
+/////      Not so Stable Headers      /////
+///////////////////////////////////////////
+
+#include "core/Executor.h"     // 15
+//#include "core/XMLPort.h"    // 14
+
+
+// Just in case some header included windows.h
+#undef min
+#undef max
Index: code/trunk/src/modules/weapons/CMakeLists.txt
===================================================================
--- code/trunk/src/modules/weapons/CMakeLists.txt	(revision 5748)
+++ code/trunk/src/modules/weapons/CMakeLists.txt	(revision 5749)
@@ -9,4 +9,7 @@
 ORXONOX_ADD_LIBRARY(weapons
   MODULE
+  FIND_HEADER_FILES
+  PCH_FILE
+    WeaponsPrecompiledHeaders.h
   DEFINE_SYMBOL
     "WEAPONS_SHARED_BUILD"
Index: code/trunk/src/modules/weapons/WeaponsPrecompiledHeaders.h
===================================================================
--- code/trunk/src/modules/weapons/WeaponsPrecompiledHeaders.h	(revision 5749)
+++ code/trunk/src/modules/weapons/WeaponsPrecompiledHeaders.h	(revision 5749)
@@ -0,0 +1,66 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Reto Grieder
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/**
+@file
+@brief
+    Compilation of the most often used header files in the weapons module
+@details
+    Updated: 13. September 2009
+    Total Files: 13
+*/
+
+#include "OrxonoxConfig.h"
+
+///////////////////////////////////////////
+/////          Stable Headers         /////
+///////////////////////////////////////////
+
+#include <LinearMath/btMotionState.h> // 10
+#include "util/OgreForwardRefs.h"     // 10
+
+///////////////////////////////////////////
+/////       All Rebuild Headers       /////
+///////////////////////////////////////////
+
+#include "core/CoreIncludes.h" // 13
+#include "core/BaseObject.h" // 13
+#include "tools/Timer.h" // 13
+
+///////////////////////////////////////////
+/////      Not so Stable Headers      /////
+///////////////////////////////////////////
+
+#include "network/synchronisable/Synchronisable.h" // 10
+//#include "worldentities/WorldEntity.h"      // 10
+//#include "weapons/projectiles/Projectile.h" // 9
+
+
+// Just in case some header included windows.h
+#undef min
+#undef max
Index: code/trunk/src/orxonox/OrxonoxPrecompiledHeaders.h
===================================================================
--- code/trunk/src/orxonox/OrxonoxPrecompiledHeaders.h	(revision 5748)
+++ code/trunk/src/orxonox/OrxonoxPrecompiledHeaders.h	(revision 5749)
@@ -30,69 +30,68 @@
 @file
 @brief
-    Compilation of the most often used header files in the orxonox executable
+    Compilation of the most often used header files in the orxonox library
+@details
+    Updated: 13. September 2009
+    Total Files: 88
 */
 
 #include "OrxonoxConfig.h"
 
-#include <cassert>
-#include <deque>
-#include <fstream>
-#include <iostream>
-#include <list>
-#include <map>
-#include <set>
-#include <sstream>
-#include <stack>
-#include <string>
-#include <vector>
+///////////////////////////////////////////
+/////          Stable Headers         /////
+///////////////////////////////////////////
 
-// Prevent headers from including winsock.h that messes with winsock2.h from ENet
-#define WIN32_LEAN_AND_MEAN
+#include <cassert>  // 87
+#include <cstring>  // 87
+#include <fstream>  // 87
+#include <iostream> // 87
+#include <map>      // 87
+#include <set>      // 87
+#include <sstream>  // 87
+#include <string>   // 87
+#include <vector>   // 87
+#include <list>     // 86
+#include <ctime>    // 82
+#include <cmath>    // 81
+#include <deque>    // 81
+#include <queue>    // 81
 
+#include <OgreMath.h>        // 81
+#include <OgreVector2.h>     // 81
+#include <OgreVector3.h>     // 81
+#include <OgreVector4.h>     // 81
+#include <OgreQuaternion.h>  // 81
+#include <OgreColourValue.h> // 81
 
-#ifdef ORXONOX_COMPILER_MSVC
+#include "util/OgreForwardRefs.h"     // 67
+#include <LinearMath/btMotionState.h> // 60
+#include "util/SubString.h" // 55
+#include <tinyxml/ticpp.h>  // 41
 
-// Note: Numbers after the include specify the number of times included (2009-06-19)
-// The sizes in MB was just to see how much the MSVC9 PCH file increases for Ogre includes
-#include <OgreMaterial.h> // 33, 2.7MB
-#include <OgreRenderable.h> // 32, 2.6MB
-#include <OgreSingleton.h> // 28, 0.0MB
-#include <OgreSceneNode.h> // 25, 1.1MB
-#include <OgreTexture.h> // 25, 0.2MB (1.1MB)
-#include <OgreMovableObject.h> // 22, 1.3MB
-#include <OgreResourceGroupManager.h> // 21, 1.4MB
-#include <OgreTechnique.h> // 18, 1.2MB
-//#include <OgreSceneManager.h> // 16, 7.4MB
+//#include <OgreRenderable.h> // 14, 5.1MB
+//#include <OgreSceneNode.h>  // 13, 1MB
+//#include <OgreResourceGroupManager.h> // 12, 1.5MB
+//#include <OgreTexture.h>       // 11, 0.6MB
+//#include <OgreMovableObject.h> // 10, 1.6MB
+//#include <OgreSceneManager.h>  // 9, 8.7MB
 
-#endif
+///////////////////////////////////////////
+/////       All Rebuild Headers       /////
+///////////////////////////////////////////
 
+#include "core/BaseObject.h"   // 82
+#include "core/CoreIncludes.h" // 80
 
-//#include <boost/preprocessor/cat.hpp> // 15
-//#include <boost/shared_ptr.hpp> // 13
-#include <LinearMath/btMotionState.h>
-#include <tinyxml/ticpp.h>
+///////////////////////////////////////////
+/////      Not so Stable Headers      /////
+///////////////////////////////////////////
+
+#include "network/synchronisable/Synchronisable.h" // 70
+#include "util/MultiType.h"    // 65
+#include "core/Executor.h"     // 55
+//#include "core/XMLPort.h"     // 41
+
 
 // Just in case some header included windows.h
 #undef min
 #undef max
-
-//--------- Orxonox files --------
-//--------------------------------
-
-//#include "util/Convert.h" // 24
-#include "util/Debug.h"
-#include "util/Exception.h"
-#include "util/Math.h"
-#include "util/OgreForwardRefs.h"
-#include "util/SubString.h"
-
-#include "core/BaseObject.h"
-//#include "core/ConfigValueIncludes.h" // 19
-//#include "core/ConsoleCommand.h" // 15
-//#include "core/Core.h" // ?, but not many times
-#include "core/CoreIncludes.h"
-#include "core/XMLPort.h"
-
-#include "network/synchronisable/Synchronisable.h"
-//#include "network/ClientInformation.h" // 26
-//#include "network/ClientConnectionListener.h" // 24